const chai = require('chai');
const chaiAsPromised = require("chai-as-promised");
const post = require('../lib/post');

chai.use(chaiAsPromised);
expect = chai.expect;

describe('#post()', () => {
    it('无效输入数据', () => {
        return expect(post()).to.be.rejectedWith(Error);
    });

    it('目标地址格式错误', () => {
        return expect(post('abcdef', {})).to.be.rejectedWith(Error);
    });

    it('目标地址不可达', async () => {
        return expect(
                post('http://lucky-byte.com:45678', {})
        ).to.be.rejectedWith(Error);
    }).timeout(120 * 1000);

    it('目标地址不可达', async () => {
        return expect(
                post('http://lucky-byte.com:45678', {}, {
                    timeout: 30,
                    retry: 50
                })
        ).to.be.rejectedWith(Error);
    }).timeout(120 * 1000);
});
