const assert = require('chai').assert;
const expect = require('chai').expect;
const utils = require('../lib/utils');

describe('utils', () => {
    describe('#parse_resp_data()', () => {
        it('无效输入数据', () => {
            expect(() => { utils.parse_resp_data('abcdef'); }).to.throw(Error);
        });
        it('正确输入数据', () => {
            expect(() => { utils.parse_resp_data('a=b&c=d='); }).to.not.throw();
        });
        it('正确输入数据，后跟多余的 & 符号', () => {
            expect(() => { utils.parse_resp_data('a=b&c=d=&'); }).to.not.throw();
        });
        it('正确输入数据，前缀多余的 & 符号', () => {
            expect(() => { utils.parse_resp_data('&a=b&c=d=&'); }).to.not.throw();
        });
    });

    describe('#gen_reqt_sign()', () => {
        it('处理参数无效异常0', () => {
            expect(() => { utils.gen_reqt_sign(); }).to.throw(Error);
        });
        it('处理参数无效异常1', () => {
            expect(() => { utils.gen_reqt_sign('1'); }).to.throw(Error);
        });
    });
});
